Index: src/unittests/Makefile.am
===================================================================
--- src/unittests/Makefile.am	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/unittests/Makefile.am	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -7,8 +7,6 @@
 AM_CXXFLAGS = $(CPPUNIT_CFLAGS)
 
-MENUTESTS = \
-  ActionSequenceTest
-
 TESTS = \
+  ActionSequenceTest \
   ActOnAllUnitTest \
   AnalysisBondsUnitTests \
@@ -18,7 +16,10 @@
   atomsCalculationTest \
   AtomDescriptorTest \
+  BaseShapesUnitTest \
   BondGraphUnitTest \
+  BoxUnittest \
   CacheableTest \
   CountBondsUnitTest \
+  FormulaUnittest \
   GSLMatrixSymmetricUnitTest \
   GSLMatrixUnitTest \
@@ -31,6 +32,5 @@
   LogUnitTest \
   manipulateAtomsTest \
-  MemoryUsageObserverUnitTest \
-  MemoryAllocatorUnitTest \
+  MatrixUnittest \
   MoleculeDescriptorTest \
   ObserverTest \
@@ -38,4 +38,5 @@
   periodentafelTest \
   PlaneUnittest \
+  ShapeUnittest \
   SingletonTest \
   StackClassUnitTest \
@@ -43,6 +44,5 @@
   Tesselation_BoundaryTriangleUnitTest \
   Tesselation_InOutsideUnitTest \
-  VectorUnitTest \
-  ${MENUTESTS}
+  VectorUnitTest
   
   
@@ -50,7 +50,18 @@
 noinst_PROGRAMS = $(TESTS) TestRunner
 
-GSLLIBS = ../libgslwrapper.a $(BOOST_LIB) ${BOOST_THREAD_LIB}
-ALLLIBS = ../libmolecuilder.a ${GSLLIBS} 
-PARSERLIBS = ../libparser.a ${ALLLIBS} 
+GSLLIBS = \
+	../LinearAlgebra/libMolecuilderLinearAlgebra-@MOLECUILDER_API_VERSION@.la \
+	../Exceptions/libMolecuilderExceptions-@MOLECUILDER_API_VERSION@.la \
+	../Helpers/libMolecuilderHelpers-@MOLECUILDER_API_VERSION@.la \
+	$(BOOST_LIB) \
+	${BOOST_THREAD_LIB}
+ALLLIBS = \
+	../Actions/libMolecuilderActions-@MOLECUILDER_API_VERSION@.la \
+	${PARSERLIBS} \
+	../libMolecuilder-@MOLECUILDER_API_VERSION@.la \
+	${GSLLIBS} \
+	${BOOST_PROGRAM_OPTIONS_LIB}
+PARSERLIBS = ../Parser/libMolecuilderParser-@MOLECUILDER_API_VERSION@.la
+UILIBS = ../UIElements/libMolecuilderUI-@MOLECUILDER_API_VERSION@.la  
 
 TESTSOURCES = \
@@ -63,7 +74,10 @@
   AtomDescriptorTest.cpp \
   atomsCalculationTest.cpp \
+  BaseShapesUnittest.cpp \
   bondgraphunittest.cpp \
+  BoxUnittest.cpp \
   CacheableTest.cpp \
   CountBondsUnitTest.cpp \
+  FormulaUnittest.cpp \
   gslmatrixsymmetricunittest.cpp \
   gslmatrixunittest.cpp \
@@ -75,7 +89,6 @@
   listofbondsunittest.cpp \
   logunittest.cpp \
+  MatrixUnittest.cpp \
   manipulateAtomsTest.cpp \
-  memoryallocatorunittest.cpp  \
-  memoryusageobserverunittest.cpp \
   MoleculeDescriptorTest.cpp \
   ObserverTest.cpp \
@@ -83,4 +96,5 @@
   periodentafelTest.cpp \
   PlaneUnittest.cpp \
+  ShapeUnittest.cpp \
   SingletonTest.cpp \
   stackclassunittest.cpp \
@@ -99,7 +113,10 @@
   AtomDescriptorTest.hpp \
   atomsCalculationTest.hpp \
+  BaseShapesUnittest.hpp \
   bondgraphunittest.hpp \
+  BoxUnittest.hpp \
   CacheableTest.hpp \
   CountBondsUnitTest.hpp \
+  FormulaUnittest.hpp \
   gslmatrixsymmetricunittest.hpp \
   gslmatrixunittest.hpp \
@@ -112,8 +129,8 @@
   logunittest.hpp \
   manipulateAtomsTest.hpp \
-  memoryallocatorunittest.hpp  \
-  memoryusageobserverunittest.hpp \
+  MatrixUnittest.hpp \
   MoleculeDescriptorTest.hpp \
   periodentafelTest.hpp \
+  ParserUnitTest.hpp \
   PlaneUnittest.hpp \
   ObserverTest.hpp \
@@ -126,6 +143,6 @@
   
 
-ActionSequenceTest_SOURCES = UnitTestMain.cpp ../../../TestRunnerClient.hpp ActionSequenceTest.cpp ActionSequenceTest.hpp
-ActionSequenceTest_LDADD = ${ALLLIBS}
+ActionSequenceTest_SOURCES = UnitTestMain.cpp ActionSequenceTest.cpp ActionSequenceTest.hpp
+ActionSequenceTest_LDADD = ${UILIBS} ${ALLLIBS}
 
 ActOnAllUnitTest_SOURCES = UnitTestMain.cpp ../test/ActOnAllTest.hpp ActOnAllUnitTest.cpp ActOnAllUnitTest.hpp
@@ -150,7 +167,13 @@
 AtomDescriptorTest_LDADD = ${ALLLIBS}
 
+BaseShapesUnitTest_SOURCES = UnitTestMain.cpp BaseShapesUnittest.cpp BaseShapesUnittest.hpp
+BaseShapesUnitTest_LDADD = ${ALLLIBS}
+
 BondGraphUnitTest_SOURCES = UnitTestMain.cpp bondgraphunittest.cpp bondgraphunittest.hpp
 BondGraphUnitTest_LDADD = ${ALLLIBS}
 
+BoxUnittest_SOURCES = UnitTestMain.cpp BoxUnittest.cpp BoxUnittest.hpp
+BoxUnittest_LDADD = ${ALLLIBS}
+
 CacheableTest_SOURCES = UnitTestMain.cpp CacheableTest.cpp CacheableTest.hpp
 CacheableTest_LDADD = ${ALLLIBS}
@@ -159,12 +182,15 @@
 CountBondsUnitTest_LDADD = ${ALLLIBS}
 
+FormulaUnittest_SOURCES = UnitTestMain.cpp FormulaUnittest.cpp FormulaUnittest.hpp
+FormulaUnittest_LDADD = ${ALLLIBS}
+
 GSLMatrixSymmetricUnitTest_SOURCES = UnitTestMain.cpp gslmatrixsymmetricunittest.cpp gslmatrixsymmetricunittest.hpp
-GSLMatrixSymmetricUnitTest_LDADD = ${GSLLIBS}
+GSLMatrixSymmetricUnitTest_LDADD = ${ALLLIBS}
 
 GSLMatrixUnitTest_SOURCES = UnitTestMain.cpp gslmatrixunittest.cpp gslmatrixunittest.hpp
-GSLMatrixUnitTest_LDADD = ${GSLLIBS}
+GSLMatrixUnitTest_LDADD = ${ALLLIBS}
 
 GSLVectorUnitTest_SOURCES = UnitTestMain.cpp gslvectorunittest.cpp gslvectorunittest.hpp
-GSLVectorUnitTest_LDADD = ${GSLLIBS}
+GSLVectorUnitTest_LDADD = ${ALLLIBS}
 
 InfoUnitTest_SOURCES = UnitTestMain.cpp infounittest.cpp infounittest.hpp
@@ -187,11 +213,8 @@
 
 manipulateAtomsTest_SOURCES = UnitTestMain.cpp manipulateAtomsTest.cpp manipulateAtomsTest.hpp
-manipulateAtomsTest_LDADD = ${ALLLIBS}
-
-MemoryAllocatorUnitTest_SOURCES = UnitTestMain.cpp ../memoryallocator.hpp ../memoryallocator.cpp ../memoryusageobserver.cpp ../memoryusageobserver.hpp memoryallocatorunittest.cpp memoryallocatorunittest.hpp 
-MemoryAllocatorUnitTest_LDADD = ${ALLLIBS}
-
-MemoryUsageObserverUnitTest_SOURCES = UnitTestMain.cpp ../memoryallocator.hpp ../memoryusageobserver.cpp ../memoryusageobserver.hpp memoryusageobserverunittest.cpp memoryusageobserverunittest.hpp 
-MemoryUsageObserverUnitTest_LDADD = ${ALLLIBS}
+manipulateAtomsTest_LDADD = ${UILIBS} ${ALLLIBS}
+
+MatrixUnittest_SOURCES = UnitTestMain.cpp MatrixUnittest.cpp MatrixUnittest.hpp
+MatrixUnittest_LDADD = ${ALLLIBS}
 
 MoleculeDescriptorTest_SOURCES = UnitTestMain.cpp MoleculeDescriptorTest.cpp MoleculeDescriptorTest.hpp
@@ -202,5 +225,5 @@
 
 ParserUnitTest_SOURCES = UnitTestMain.cpp ParserUnitTest.cpp ParserUnitTest.hpp
-ParserUnitTest_LDADD = ${PARSERLIBS}
+ParserUnitTest_LDADD = ${ALLLIBS} 
 
 periodentafelTest_SOURCES = UnitTestMain.cpp periodentafelTest.cpp periodentafelTest.hpp
@@ -210,4 +233,7 @@
 PlaneUnittest_LDADD = ${ALLLIBS}
 
+ShapeUnittest_SOURCES = UnitTestMain.cpp ShapeUnittest.cpp ShapeUnittest.hpp
+ShapeUnittest_LDADD = ${ALLLIBS}
+
 SingletonTest_SOURCES = UnitTestMain.cpp SingletonTest.cpp SingletonTest.hpp
 SingletonTest_LDADD = ${ALLLIBS} $(BOOST_LIB) ${BOOST_THREAD_LIB}
@@ -225,6 +251,6 @@
 Tesselation_InOutsideUnitTest_LDADD = ${ALLLIBS}
 
-TestRunner_SOURCES = TestRunnerMain.cpp ../memoryallocator.hpp ../memoryallocator.cpp ../memoryusageobserver.cpp ../memoryusageobserver.hpp $(TESTSOURCES) $(TESTHEADERS)
-TestRunner_LDADD = ${ALLLIBS}
+TestRunner_SOURCES = TestRunnerMain.cpp $(TESTSOURCES) $(TESTHEADERS)
+TestRunner_LDADD = ${UILIBS} ${ALLLIBS}
 
 VectorUnitTest_SOURCES = UnitTestMain.cpp vectorunittest.cpp vectorunittest.hpp 
Index: src/unittests/MapofActionsTest.cpp
===================================================================
--- src/unittests/MapofActionsTest.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/unittests/MapofActionsTest.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: heber
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 using namespace std;
Index: src/unittests/MatrixUnittest.cpp
===================================================================
--- src/unittests/MatrixUnittest.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/unittests/MatrixUnittest.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,351 @@
+/*
+ * MatrixUnittest.cpp
+ *
+ *  Created on: Jul 7, 2010
+ *      Author: crueger
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <cppunit/CompilerOutputter.h>
+#include <cppunit/extensions/TestFactoryRegistry.h>
+#include <cppunit/ui/text/TestRunner.h>
+
+#include <cmath>
+
+#include "MatrixUnittest.hpp"
+#include "LinearAlgebra/Matrix.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "Exceptions/NotInvertibleException.hpp"
+
+#ifdef HAVE_TESTRUNNER
+#include "UnitTestMain.hpp"
+#endif /*HAVE_TESTRUNNER*/
+
+// Registers the fixture into the 'registry'
+CPPUNIT_TEST_SUITE_REGISTRATION( MatrixUnittest );
+
+void MatrixUnittest::setUp(){
+  zero = new Matrix();
+  one = new Matrix();
+  for(int i =NDIM;i--;){
+    one->at(i,i)=1.;
+  }
+  full=new Matrix();
+  for(int i=NDIM;i--;){
+    for(int j=NDIM;j--;){
+      full->at(i,j)=1.;
+    }
+  }
+  diagonal = new Matrix();
+  for(int i=NDIM;i--;){
+    diagonal->at(i,i)=i+1.;
+  }
+  perm1 = new Matrix();
+  perm1->column(0) = e1;
+  perm1->column(1) = e3;
+  perm1->column(2) = e2;
+
+
+  perm2 = new Matrix();
+  perm2->column(0) = e2;
+  perm2->column(1) = e1;
+  perm2->column(2) = e3;
+
+  perm3 = new Matrix();
+  perm3->column(0) = e2;
+  perm3->column(1) = e3;
+  perm3->column(2) = e1;
+
+  perm4 = new Matrix();
+  perm4->column(0) = e3;
+  perm4->column(1) = e2;
+  perm4->column(2) = e1;
+
+  perm5 = new Matrix();
+  perm5->column(0) = e3;
+  perm5->column(1) = e1;
+  perm5->column(2) = e2;
+
+}
+void MatrixUnittest::tearDown(){
+  delete zero;
+  delete one;
+  delete full;
+  delete diagonal;
+  delete perm1;
+  delete perm2;
+  delete perm3;
+  delete perm4;
+  delete perm5;
+}
+
+void MatrixUnittest::AccessTest(){
+  Matrix mat;
+  for(int i=NDIM;i--;){
+    for(int j=NDIM;j--;){
+      CPPUNIT_ASSERT_EQUAL(mat.at(i,j),0.);
+    }
+  }
+  int k=1;
+  for(int i=NDIM;i--;){
+    for(int j=NDIM;j--;){
+      mat.at(i,j)=k++;
+    }
+  }
+  k=1;
+  for(int i=NDIM;i--;){
+    for(int j=NDIM;j--;){
+      CPPUNIT_ASSERT_EQUAL(mat.at(i,j),(double)k);
+      ++k;
+    }
+  }
+}
+
+void MatrixUnittest::VectorTest(){
+  Matrix mat;
+  for(int i=NDIM;i--;){
+    CPPUNIT_ASSERT_EQUAL(mat.row(i),zeroVec);
+    CPPUNIT_ASSERT_EQUAL(mat.column(i),zeroVec);
+  }
+  CPPUNIT_ASSERT_EQUAL(mat.diagonal(),zeroVec);
+
+  mat.one();
+  CPPUNIT_ASSERT_EQUAL(mat.row(0),e1);
+  CPPUNIT_ASSERT_EQUAL(mat.row(1),e2);
+  CPPUNIT_ASSERT_EQUAL(mat.row(2),e3);
+  CPPUNIT_ASSERT_EQUAL(mat.column(0),e1);
+  CPPUNIT_ASSERT_EQUAL(mat.column(1),e2);
+  CPPUNIT_ASSERT_EQUAL(mat.column(2),e3);
+
+  Vector t1=Vector(1.,1.,1.);
+  Vector t2=Vector(2.,2.,2.);
+  Vector t3=Vector(3.,3.,3.);
+  Vector t4=Vector(1.,2.,3.);
+
+  mat.row(0)=t1;
+  mat.row(1)=t2;
+  mat.row(2)=t3;
+  CPPUNIT_ASSERT_EQUAL(mat.row(0),t1);
+  CPPUNIT_ASSERT_EQUAL(mat.row(1),t2);
+  CPPUNIT_ASSERT_EQUAL(mat.row(2),t3);
+  CPPUNIT_ASSERT_EQUAL(mat.column(0),t4);
+  CPPUNIT_ASSERT_EQUAL(mat.column(1),t4);
+  CPPUNIT_ASSERT_EQUAL(mat.column(2),t4);
+  CPPUNIT_ASSERT_EQUAL(mat.diagonal(),t4);
+  for(int i=NDIM;i--;){
+    for(int j=NDIM;j--;){
+      CPPUNIT_ASSERT_EQUAL(mat.at(i,j),i+1.);
+    }
+  }
+
+  mat.column(0)=t1;
+  mat.column(1)=t2;
+  mat.column(2)=t3;
+  CPPUNIT_ASSERT_EQUAL(mat.column(0),t1);
+  CPPUNIT_ASSERT_EQUAL(mat.column(1),t2);
+  CPPUNIT_ASSERT_EQUAL(mat.column(2),t3);
+  CPPUNIT_ASSERT_EQUAL(mat.row(0),t4);
+  CPPUNIT_ASSERT_EQUAL(mat.row(1),t4);
+  CPPUNIT_ASSERT_EQUAL(mat.row(2),t4);
+  CPPUNIT_ASSERT_EQUAL(mat.diagonal(),t4);
+  for(int i=NDIM;i--;){
+    for(int j=NDIM;j--;){
+      CPPUNIT_ASSERT_EQUAL(mat.at(i,j),j+1.);
+    }
+  }
+}
+
+void MatrixUnittest::TransposeTest(){
+  Matrix res;
+
+  // transpose of unit is unit
+  res.one();
+  (const Matrix)res.transpose();
+  CPPUNIT_ASSERT_EQUAL(res,*one);
+
+  // transpose of transpose is same matrix
+  res.zero();
+  res.set(2,2, 1.);
+  CPPUNIT_ASSERT_EQUAL(res.transpose().transpose(),res);
+}
+
+void MatrixUnittest::OperationTest(){
+  Matrix res;
+
+  res =(*zero) *(*zero);
+  CPPUNIT_ASSERT_EQUAL(res,*zero);
+  res =(*zero) *(*one);
+  CPPUNIT_ASSERT_EQUAL(res,*zero);
+  res =(*zero) *(*full);
+  CPPUNIT_ASSERT_EQUAL(res,*zero);
+  res =(*zero) *(*diagonal);
+  CPPUNIT_ASSERT_EQUAL(res,*zero);
+  res =(*zero) *(*perm1);
+  CPPUNIT_ASSERT_EQUAL(res,*zero);
+  res =(*zero) *(*perm2);
+  CPPUNIT_ASSERT_EQUAL(res,*zero);
+  res =(*zero) *(*perm3);
+  CPPUNIT_ASSERT_EQUAL(res,*zero);
+  res =(*zero) *(*perm4);
+  CPPUNIT_ASSERT_EQUAL(res,*zero);
+  res =(*zero) *(*perm5);
+  CPPUNIT_ASSERT_EQUAL(res,*zero);
+
+  res =(*one)*(*one);
+  CPPUNIT_ASSERT_EQUAL(res,*one);
+  res =(*one)*(*full);
+  CPPUNIT_ASSERT_EQUAL(res,*full);
+  res =(*one)*(*diagonal);
+  CPPUNIT_ASSERT_EQUAL(res,*diagonal);
+  res =(*one)*(*perm1);
+  CPPUNIT_ASSERT_EQUAL(res,*perm1);
+  res =(*one)*(*perm2);
+  CPPUNIT_ASSERT_EQUAL(res,*perm2);
+  res =(*one)*(*perm3);
+  CPPUNIT_ASSERT_EQUAL(res,*perm3);
+  res =(*one)*(*perm4);
+  CPPUNIT_ASSERT_EQUAL(res,*perm4);
+  res =(*one)*(*perm5);
+  CPPUNIT_ASSERT_EQUAL(res,*perm5);
+
+  res = (*full)*(*perm1);
+  CPPUNIT_ASSERT_EQUAL(res,*full);
+  res = (*full)*(*perm2);
+  CPPUNIT_ASSERT_EQUAL(res,*full);
+  res = (*full)*(*perm3);
+  CPPUNIT_ASSERT_EQUAL(res,*full);
+  res = (*full)*(*perm4);
+  CPPUNIT_ASSERT_EQUAL(res,*full);
+  res = (*full)*(*perm5);
+  CPPUNIT_ASSERT_EQUAL(res,*full);
+
+  res = (*diagonal)*(*perm1);
+  CPPUNIT_ASSERT_EQUAL(res.column(0),e1);
+  CPPUNIT_ASSERT_EQUAL(res.column(1),3*e3);
+  CPPUNIT_ASSERT_EQUAL(res.column(2),2*e2);
+  res = (*diagonal)*(*perm2);
+  CPPUNIT_ASSERT_EQUAL(res.column(0),2*e2);
+  CPPUNIT_ASSERT_EQUAL(res.column(1),e1);
+  CPPUNIT_ASSERT_EQUAL(res.column(2),3*e3);
+  res = (*diagonal)*(*perm3);
+  CPPUNIT_ASSERT_EQUAL(res.column(0),2*e2);
+  CPPUNIT_ASSERT_EQUAL(res.column(1),3*e3);
+  CPPUNIT_ASSERT_EQUAL(res.column(2),e1);
+  res = (*diagonal)*(*perm4);
+  CPPUNIT_ASSERT_EQUAL(res.column(0),3*e3);
+  CPPUNIT_ASSERT_EQUAL(res.column(1),2*e2);
+  CPPUNIT_ASSERT_EQUAL(res.column(2),e1);
+  res = (*diagonal)*(*perm5);
+  CPPUNIT_ASSERT_EQUAL(res.column(0),3*e3);
+  CPPUNIT_ASSERT_EQUAL(res.column(1),e1);
+  CPPUNIT_ASSERT_EQUAL(res.column(2),2*e2);
+}
+
+void MatrixUnittest::RotationTest(){
+  Matrix res;
+  Matrix inverse;
+
+  // zero rotation angles yields unity matrix
+  res.rotation(0,0,0);
+  CPPUNIT_ASSERT_EQUAL(*one, res);
+
+  // arbitrary rotation matrix has det = 1
+  res.rotation(M_PI/3.,1.,M_PI/7.);
+  CPPUNIT_ASSERT(fabs(fabs(res.determinant()) -1.) < MYEPSILON);
+
+  // inverse is rotation matrix with negative angles
+  res.rotation(M_PI/3.,0.,0.);
+  inverse.rotation(-M_PI/3.,0.,0.);
+  CPPUNIT_ASSERT_EQUAL(*one, res * inverse);
+
+  // ... or transposed
+  res.rotation(M_PI/3.,0.,0.);
+  CPPUNIT_ASSERT_EQUAL(inverse, ((const Matrix) res).transpose());
+}
+
+void MatrixUnittest::InvertTest(){
+  CPPUNIT_ASSERT_THROW(zero->invert(),NotInvertibleException);
+  CPPUNIT_ASSERT_THROW(full->invert(),NotInvertibleException);
+
+  Matrix res;
+  res = (*one)*one->invert();
+  CPPUNIT_ASSERT_EQUAL(res,*one);
+  res = (*diagonal)*diagonal->invert();
+  CPPUNIT_ASSERT_EQUAL(res,*one);
+  res = (*perm1)*perm1->invert();
+  CPPUNIT_ASSERT_EQUAL(res,*one);
+  res = (*perm2)*perm2->invert();
+  CPPUNIT_ASSERT_EQUAL(res,*one);
+  res = (*perm3)*perm3->invert();
+  CPPUNIT_ASSERT_EQUAL(res,*one);
+  res = (*perm4)*perm4->invert();
+  CPPUNIT_ASSERT_EQUAL(res,*one);
+  res = (*perm5)*perm5->invert();
+  CPPUNIT_ASSERT_EQUAL(res,*one);
+}
+
+
+void MatrixUnittest::DeterminantTest(){
+  CPPUNIT_ASSERT_EQUAL(zero->determinant(),0.);
+  CPPUNIT_ASSERT_EQUAL(one->determinant(),1.);
+  CPPUNIT_ASSERT_EQUAL(diagonal->determinant(),6.);
+  CPPUNIT_ASSERT_EQUAL(full->determinant(),0.);
+  CPPUNIT_ASSERT_EQUAL(perm1->determinant(),-1.);
+  CPPUNIT_ASSERT_EQUAL(perm2->determinant(),-1.);
+  CPPUNIT_ASSERT_EQUAL(perm3->determinant(),1.);
+  CPPUNIT_ASSERT_EQUAL(perm4->determinant(),-1.);
+  CPPUNIT_ASSERT_EQUAL(perm5->determinant(),1.);
+}
+
+void MatrixUnittest::VecMultTest(){
+  CPPUNIT_ASSERT_EQUAL((*zero)*e1,zeroVec);
+  CPPUNIT_ASSERT_EQUAL((*zero)*e2,zeroVec);
+  CPPUNIT_ASSERT_EQUAL((*zero)*e3,zeroVec);
+  CPPUNIT_ASSERT_EQUAL((*zero)*zeroVec,zeroVec);
+
+  CPPUNIT_ASSERT_EQUAL((*one)*e1,e1);
+  CPPUNIT_ASSERT_EQUAL((*one)*e2,e2);
+  CPPUNIT_ASSERT_EQUAL((*one)*e3,e3);
+  CPPUNIT_ASSERT_EQUAL((*one)*zeroVec,zeroVec);
+
+  CPPUNIT_ASSERT_EQUAL((*diagonal)*e1,e1);
+  CPPUNIT_ASSERT_EQUAL((*diagonal)*e2,2*e2);
+  CPPUNIT_ASSERT_EQUAL((*diagonal)*e3,3*e3);
+  CPPUNIT_ASSERT_EQUAL((*diagonal)*zeroVec,zeroVec);
+
+  CPPUNIT_ASSERT_EQUAL((*perm1)*e1,e1);
+  CPPUNIT_ASSERT_EQUAL((*perm1)*e2,e3);
+  CPPUNIT_ASSERT_EQUAL((*perm1)*e3,e2);
+  CPPUNIT_ASSERT_EQUAL((*perm1)*zeroVec,zeroVec);
+
+  CPPUNIT_ASSERT_EQUAL((*perm2)*e1,e2);
+  CPPUNIT_ASSERT_EQUAL((*perm2)*e2,e1);
+  CPPUNIT_ASSERT_EQUAL((*perm2)*e3,e3);
+  CPPUNIT_ASSERT_EQUAL((*perm2)*zeroVec,zeroVec);
+
+  CPPUNIT_ASSERT_EQUAL((*perm3)*e1,e2);
+  CPPUNIT_ASSERT_EQUAL((*perm3)*e2,e3);
+  CPPUNIT_ASSERT_EQUAL((*perm3)*e3,e1);
+  CPPUNIT_ASSERT_EQUAL((*perm3)*zeroVec,zeroVec);
+
+  CPPUNIT_ASSERT_EQUAL((*perm4)*e1,e3);
+  CPPUNIT_ASSERT_EQUAL((*perm4)*e2,e2);
+  CPPUNIT_ASSERT_EQUAL((*perm4)*e3,e1);
+  CPPUNIT_ASSERT_EQUAL((*perm4)*zeroVec,zeroVec);
+
+  CPPUNIT_ASSERT_EQUAL((*perm5)*e1,e3);
+  CPPUNIT_ASSERT_EQUAL((*perm5)*e2,e1);
+  CPPUNIT_ASSERT_EQUAL((*perm5)*e3,e2);
+  CPPUNIT_ASSERT_EQUAL((*perm5)*zeroVec,zeroVec);
+
+  Vector t = Vector(1.,2.,3.);
+  CPPUNIT_ASSERT_EQUAL((*perm1)*t,Vector(1,3,2));
+  CPPUNIT_ASSERT_EQUAL((*perm2)*t,Vector(2,1,3));
+  CPPUNIT_ASSERT_EQUAL((*perm3)*t,Vector(3,1,2));
+  CPPUNIT_ASSERT_EQUAL((*perm4)*t,Vector(3,2,1));
+  CPPUNIT_ASSERT_EQUAL((*perm5)*t,Vector(2,3,1));
+}
Index: src/unittests/MatrixUnittest.hpp
===================================================================
--- src/unittests/MatrixUnittest.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/unittests/MatrixUnittest.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,52 @@
+/*
+ * MatrixUnittest.hpp
+ *
+ *  Created on: Jul 7, 2010
+ *      Author: crueger
+ */
+
+#ifndef MATRIXUNITTEST_HPP_
+#define MATRIXUNITTEST_HPP_
+
+#include <cppunit/extensions/HelperMacros.h>
+
+class Matrix;
+
+class MatrixUnittest : public CppUnit::TestFixture
+{
+  CPPUNIT_TEST_SUITE( MatrixUnittest) ;
+  CPPUNIT_TEST ( AccessTest );
+  CPPUNIT_TEST ( VectorTest );
+  CPPUNIT_TEST ( OperationTest );
+  CPPUNIT_TEST ( TransposeTest );
+  CPPUNIT_TEST ( RotationTest );
+  CPPUNIT_TEST ( InvertTest );
+  CPPUNIT_TEST ( DeterminantTest );
+  CPPUNIT_TEST ( VecMultTest );
+  CPPUNIT_TEST_SUITE_END();
+
+public:
+  void setUp();
+  void tearDown();
+
+  void AccessTest();
+  void VectorTest();
+  void OperationTest();
+  void TransposeTest();
+  void RotationTest();
+  void InvertTest();
+  void DeterminantTest();
+  void VecMultTest();
+
+  Matrix *zero;
+  Matrix *one;
+  Matrix *full;
+  Matrix *diagonal;
+  Matrix *perm1;
+  Matrix *perm2;
+  Matrix *perm3;
+  Matrix *perm4;
+  Matrix *perm5;
+};
+
+#endif /* MATRIXUNITTEST_HPP_ */
Index: src/unittests/MoleculeDescriptorTest.cpp
===================================================================
--- src/unittests/MoleculeDescriptorTest.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/unittests/MoleculeDescriptorTest.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "MoleculeDescriptorTest.hpp"
Index: src/unittests/MoleculeDescriptorTest.hpp
===================================================================
--- src/unittests/MoleculeDescriptorTest.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/unittests/MoleculeDescriptorTest.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -13,5 +13,6 @@
 #include "types.hpp"
 
-#define MOLECULE_COUNT (10)
+// we prefer enum over define
+enum { MOLECULE_COUNT = 10 };
 
 class molecule;
Index: src/unittests/ObserverTest.cpp
===================================================================
--- src/unittests/ObserverTest.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/unittests/ObserverTest.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,4 +6,9 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "ObserverTest.hpp"
 
@@ -182,5 +187,5 @@
 };
 
-class ObservableCollection : public Observable {
+class ObservableSet : public Observable {
 public:
   typedef std::set<SimpleObservable*> set;
@@ -188,5 +193,5 @@
   typedef set::const_iterator const_iterator;
 
-  ObservableCollection(int _num) :
+  ObservableSet(int _num) :
     Observable("ObservableCollection"),
     num(_num)
@@ -199,8 +204,46 @@
   }
 
-  ~ObservableCollection(){
+  ~ObservableSet(){
     set::iterator iter;
     for(iter=theSet.begin(); iter!=theSet.end(); ++iter ){
       delete (*iter);
+    }
+  }
+
+  iterator begin(){
+    return iterator(theSet.begin(),this);
+  }
+
+  iterator end(){
+    return iterator(theSet.end(),this);
+  }
+
+  const int num;
+
+private:
+  set theSet;
+};
+
+class ObservableMap : public Observable {
+public:
+  typedef std::map<int,SimpleObservable*> set;
+  typedef ObservedIterator<set> iterator;
+  typedef set::const_iterator const_iterator;
+
+  ObservableMap(int _num) :
+    Observable("ObservableCollection"),
+    num(_num)
+  {
+    for(int i=0; i<num; ++i){
+      SimpleObservable *content = new SimpleObservable();
+      content->signOn(this);
+      theSet.insert(make_pair(i,content));
+    }
+  }
+
+  ~ObservableMap(){
+    set::iterator iter;
+    for(iter=theSet.begin(); iter!=theSet.end(); ++iter ){
+      delete iter->second;
     }
   }
@@ -231,5 +274,6 @@
   blockObservable = new BlockObservable();
   notificationObservable = new NotificationObservable();
-  collection = new ObservableCollection(5);
+  obsset = new ObservableSet(5);
+  obsmap = new ObservableMap(5);
 
   observer1 = new UpdateCountObserver();
@@ -249,5 +293,6 @@
   delete blockObservable;
   delete notificationObservable;
-  delete collection;
+  delete obsset;
+  delete obsmap;
 
   delete observer1;
@@ -268,4 +313,10 @@
   simpleObservable2->signOn(observer4);
 
+  CPPUNIT_ASSERT_EQUAL( 0, observer1->updates );
+  CPPUNIT_ASSERT_EQUAL( 0, observer2->updates );
+  CPPUNIT_ASSERT_EQUAL( 0, observer3->updates );
+  CPPUNIT_ASSERT_EQUAL( 0, observer4->updates );
+
+
   simpleObservable1->changeMethod();
   CPPUNIT_ASSERT_EQUAL( 1, observer1->updates );
@@ -292,4 +343,5 @@
 void ObserverTest::doesBlockUpdateTest() {
   callObservable->signOn(observer1);
+  CPPUNIT_ASSERT_EQUAL( 0, observer1->updates );
 
   callObservable->changeMethod1();
@@ -311,4 +363,16 @@
   CPPUNIT_ASSERT_EQUAL( 2, observer1->updates );
   CPPUNIT_ASSERT_EQUAL( 2, observer2->updates );
+}
+
+void ObserverTest::outsideLockTest(){
+  callObservable->signOn(observer1);
+  CPPUNIT_ASSERT_EQUAL( 0, observer1->updates );
+
+  {
+    LOCK_OBSERVABLE(*callObservable);
+    CPPUNIT_ASSERT_EQUAL( 0, observer1->updates );
+  }
+  // lock is gone now, observer should have notified
+  CPPUNIT_ASSERT_EQUAL( 1, observer1->updates );
 }
 
@@ -341,21 +405,21 @@
   int i = 0;
   // test the general iterator methods
-  for(ObservableCollection::iterator iter=collection->begin(); iter!=collection->end();++iter){
-    CPPUNIT_ASSERT(i< collection->num);
+  for(ObservableSet::iterator iter=obsset->begin(); iter!=obsset->end();++iter){
+    CPPUNIT_ASSERT(i< obsset->num);
     i++;
   }
 
   i=0;
-  for(ObservableCollection::const_iterator iter=collection->begin(); iter!=collection->end();++iter){
-    CPPUNIT_ASSERT(i<collection->num);
-    i++;
-  }
-
-  collection->signOn(observer1);
+  for(ObservableSet::const_iterator iter=obsset->begin(); iter!=obsset->end();++iter){
+    CPPUNIT_ASSERT(i<obsset->num);
+    i++;
+  }
+
+  obsset->signOn(observer1);
   {
     // we construct this out of the loop, so the iterator dies at the end of
     // the scope and not the end of the loop (allows more testing)
-    ObservableCollection::iterator iter;
-    for(iter=collection->begin(); iter!=collection->end(); ++iter){
+    ObservableSet::iterator iter;
+    for(iter=obsset->begin(); iter!=obsset->end(); ++iter){
       (*iter)->changeMethod();
     }
@@ -367,7 +431,25 @@
 
   // when using a const_iterator no changes should be propagated
-  for(ObservableCollection::const_iterator iter = collection->begin(); iter!=collection->end();++iter);
+  for(ObservableSet::const_iterator iter = obsset->begin(); iter!=obsset->end();++iter);
   CPPUNIT_ASSERT_EQUAL( 1, observer1->updates);
-  collection->signOff(observer1);
+
+  // we need to test the operator-> as well
+  obsmap->signOn(observer2);
+  {
+    // we construct this out of the loop, so the iterator dies at the end of
+    // the scope and not the end of the loop (allows more testing)
+    ObservableMap::iterator iter;
+    for(iter=obsmap->begin(); iter!=obsmap->end(); ++iter){
+      iter->second->changeMethod();
+    }
+    // At this point no change should have been propagated
+    CPPUNIT_ASSERT_EQUAL( 0, observer2->updates);
+  }
+  // After the Iterator has died the propagation should take place
+  CPPUNIT_ASSERT_EQUAL( 1, observer2->updates);
+
+
+  obsset->signOff(observer1);
+  obsmap->signOff(observer2);
 }
 
Index: src/unittests/ObserverTest.hpp
===================================================================
--- src/unittests/ObserverTest.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/unittests/ObserverTest.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -17,5 +17,6 @@
 class CallObservable;
 class SuperObservable;
-class ObservableCollection;
+class ObservableSet;
+class ObservableMap;
 class BlockObservable;
 class NotificationObservable;
@@ -27,4 +28,5 @@
   CPPUNIT_TEST ( doesBlockUpdateTest );
   CPPUNIT_TEST ( doesSubObservableTest );
+  CPPUNIT_TEST ( outsideLockTest );
   CPPUNIT_TEST ( doesNotifyTest );
   CPPUNIT_TEST ( doesReportTest );
@@ -40,4 +42,5 @@
   void doesBlockUpdateTest();
   void doesSubObservableTest();
+  void outsideLockTest();
   void doesNotifyTest();
   void doesReportTest();
@@ -60,5 +63,6 @@
   SuperObservable *superObservable;
   NotificationObservable *notificationObservable;
-  ObservableCollection *collection;
+  ObservableSet *obsset;
+  ObservableMap *obsmap;
 
 };
Index: src/unittests/ParserUnitTest.cpp
===================================================================
--- src/unittests/ParserUnitTest.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/unittests/ParserUnitTest.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: metzler
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "ParserUnitTest.hpp"
@@ -208,5 +213,5 @@
   input << Tremolo_Atomdata2;
   testParser->load(&input);
-  CPPUNIT_ASSERT(World::getInstance().getAtom(AtomByType(1))->x[0] == 3.0);
+  CPPUNIT_ASSERT(World::getInstance().getAtom(AtomByType(1))->at(0) == 3.0);
   input.clear();
 }
@@ -219,5 +224,5 @@
   input << Tremolo_velocity;
   testParser->load(&input);
-  CPPUNIT_ASSERT(World::getInstance().getAtom(AtomByType(1))->v[0] == 3.0);
+  CPPUNIT_ASSERT(World::getInstance().getAtom(AtomByType(1))->AtomicVelocity[0] == 3.0);
   input.clear();
 }
@@ -271,5 +276,5 @@
   // with the maximum number of fields and minimal information, default values are printed
   atom* newAtom = World::getInstance().createAtom();
-  newAtom->type = World::getInstance().getPeriode()->FindElement(1);
+  newAtom->setType(1);
   testParser->setFieldsForSave("x=3 u=3 F stress Id neighbors=5 imprData GroupMeasureTypeNo Type extType name resName chainID resSeq occupancy tempFactor segID Charge charge GrpTypeNo torsion");
   testParser->save(&output);
@@ -304,12 +309,12 @@
   atom *Walker = NULL;
   Walker = World::getInstance().createAtom();
-  Walker->type = World::getInstance().getPeriode()->FindElement(8);
-  Walker->x = Vector(0,0,0);
+  Walker->setType(8);
+  Walker->setPosition(Vector(0,0,0));
   Walker = World::getInstance().createAtom();
-  Walker->type = World::getInstance().getPeriode()->FindElement(1);
-  Walker->x = Vector(0.758602,0,0.504284);
+  Walker->setType(1);
+  Walker->setPosition(Vector(0.758602,0,0.504284));
   Walker = World::getInstance().createAtom();
-  Walker->type = World::getInstance().getPeriode()->FindElement(1);
-  Walker->x = Vector(0.758602,0,-0.504284);
+  Walker->setType(1);
+  Walker->setPosition(Vector(0.758602,0,-0.504284));
   CPPUNIT_ASSERT_EQUAL(3, World::getInstance().numAtoms());
 
Index: src/unittests/PlaneUnittest.cpp
===================================================================
--- src/unittests/PlaneUnittest.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/unittests/PlaneUnittest.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,4 +6,9 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "PlaneUnittest.hpp"
 
@@ -12,10 +17,12 @@
 #include <cppunit/ui/text/TestRunner.h>
 
+#include <cmath>
+
 #ifdef HAVE_TESTRUNNER
 #include "UnitTestMain.hpp"
 #endif /*HAVE_TESTRUNNER*/
 
-#include "vector.hpp"
-#include "Line.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "LinearAlgebra/Line.hpp"
 
 CPPUNIT_TEST_SUITE_REGISTRATION( PlaneUnittest );
Index: src/unittests/PlaneUnittest.hpp
===================================================================
--- src/unittests/PlaneUnittest.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/unittests/PlaneUnittest.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -11,5 +11,5 @@
 #include <cppunit/extensions/HelperMacros.h>
 
-#include "Plane.hpp"
+#include "LinearAlgebra/Plane.hpp"
 
 class PlaneUnittest : public CppUnit::TestFixture
